# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%global namedversion %{version}
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           maven-enforcer
Version:        1.0.1
Release:        5%{?dist}
Epoch:          2
Summary:        Maven Enforcer
Group:          Development/Java
License:        ASL 2.0
URL:            http://maven.apache.org/enforcer
# svn export http://svn.apache.org/repos/asf/maven/enforcer/tags/1.0.1 maven-enforcer-1.0.1 && tar cjf maven-enforcer-1.0.1.tar.bz2 maven-enforcer-1.0.1
Source0:        maven-enforcer-%{namedversion}.tar.bz2
Patch0:         fix-site.patch
Patch1:         enforcer-rules-pom.patch
# FIXME: we can enable if we can get the right plexus-container-default to be used
Patch2:         maven-enforcer-skip-tests.patch
Patch3:         maven-enforcer-plexus-javadoc.patch
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
Requires:       java >= 0:1.6.0
Requires:       jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
Requires:       apache-commons-lang
BuildRequires:  apache-commons-lang
Requires:       easymock
BuildRequires:  easymock
Requires:       junit
BuildRequires:  junit
Requires:       maven-shared-common-artifact-filters
BuildRequires:  maven-shared-common-artifact-filters
Requires:       maven-shared-dependency-tree
BuildRequires:  maven-shared-dependency-tree
Requires:       bsh2
BuildRequires:  bsh2
Requires:       plexus-container-default
BuildRequires:  plexus-container-default
Requires:       plexus-i18n
BuildRequires:  plexus-i18n
Requires:       plexus-maven-plugin
BuildRequires:  plexus-maven-plugin
Requires:       plexus-utils
BuildRequires:  plexus-utils
BuildRequires:  maven2
BuildRequires:  maven2-common-poms
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven-plugin-tools-javadoc
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-shared-plugin-testing-harness
BuildRequires:  cobertura-maven-plugin
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  plexus-containers-component-javadoc

%description
Enforcer is a build rule execution framework.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.

%package api
Summary:        Enforcer API
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description api
This component provides the generic interfaces needed to 
implement custom rules for the maven-enforcer-plugin.

%package rules
Summary:        Enforcer Rules
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{name}-api = %{epoch}:%{version}-%{release}

%description rules
This component contains the standard Enforcer Rules.

%package -n maven-enforcer-plugin
Summary:        Enforcer Rules
Group:          Development/Java
Obsoletes:      maven2-plugin-enforcer <= 1:1.0.1
Provides:       maven2-plugin-enforcer = %{epoch}:%{version}-%{release}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{name}-rules = %{epoch}:%{version}-%{release}

%description -n maven-enforcer-plugin
This component contains the standard Enforcer Rules.

%prep
%setup -q
%patch0 -p0 -b .sav0
%if 0
%patch1 -p0 -b .sav1
%patch2 -p1 -b .sav2
%endif
%patch3 -p1 -b .sav3

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file://`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.skip=false deploy javadoc:aggregate

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p enforcer-api/target/enforcer-api-%{namedversion}.jar %{buildroot}%{_javadir}/enforcer-api-%{namedversion}.jar
%{__cp} -p enforcer-rules/target/enforcer-rules-%{namedversion}.jar %{buildroot}%{_javadir}/enforcer-rules-%{namedversion}.jar
%{__cp} -p enforcer-rules/target/enforcer-rules-%{namedversion}-tests.jar %{buildroot}%{_javadir}/enforcer-rules-%{namedversion}-tests.jar

%{__cp} -p maven-enforcer-plugin/target/maven-enforcer-plugin-%{namedversion}.jar %{buildroot}%{_javadir}/maven-enforcer-plugin-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms

%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-enforcer.pom
%add_to_maven_depmap org.apache.maven.enforcer enforcer %{namedversion} JPP enforcer
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/enforcer

%{__cp} -p enforcer-api/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-enforcer-api.pom
%add_to_maven_depmap org.apache.maven.enforcer enforcer-api %{namedversion} JPP enforcer-api
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/enforcer-api

%{__cp} -p enforcer-rules/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-enforcer-rules.pom
%add_to_maven_depmap org.apache.maven.enforcer enforcer-rules %{namedversion} JPP enforcer-rules
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/enforcer-rules

%{__cp} -p maven-enforcer-plugin/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-maven-enforcer-plugin.pom
%add_to_maven_depmap org.apache.maven.plugins maven-enforcer-plugin %{namedversion} JPP maven-enforcer-plugin
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/maven-enforcer-plugin

%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%post api
%update_maven_depmap

%postun api
%update_maven_depmap

%post rules
%update_maven_depmap

%postun rules
%update_maven_depmap

%post -n maven-enforcer-plugin
%update_maven_depmap

%postun -n maven-enforcer-plugin
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%{_datadir}/maven2/poms/JPP-enforcer.pom
%{_mavendepmapfragdir}/enforcer

%files api
%defattr(0644,root,root,0755)
%{_javadir}*/enforcer-api-%{namedversion}.jar
%{_javadir}*/enforcer-api.jar
%{_datadir}/maven2/poms/JPP-enforcer-api.pom
%{_mavendepmapfragdir}/enforcer-api

%files rules
%defattr(0644,root,root,0755)
%{_javadir}*/enforcer-rules-%{namedversion}.jar
%{_javadir}*/enforcer-rules.jar
%{_javadir}*/enforcer-rules-%{namedversion}-tests.jar
%{_javadir}*/enforcer-rules-tests.jar
%{_datadir}/maven2/poms/JPP-enforcer-rules.pom
%{_mavendepmapfragdir}/enforcer-rules

%files -n maven-enforcer-plugin
%defattr(0644,root,root,0755)
%{_javadir}*/maven-enforcer-plugin-%{namedversion}.jar
%{_javadir}*/maven-enforcer-plugin.jar
%{_datadir}/maven2/poms/JPP-maven-enforcer-plugin.pom
%{_mavendepmapfragdir}/maven-enforcer-plugin

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%changelog
* Sat Jun 16 2012 Ralph Apel <r.apel@r-apel.de> 1.0.1-5
- Avoid FileDigest and PayloadIsXz problems on EL5

* Mon Jun 04 2012 Ralph Apel <r.apel@r-apel.de> 1.0.1-4
- Obsolete maven2-plugin-enforcer <= 1:1.0.1

* Mon Jan 23 2012 Ralph Apel <r.apel@r-apel.de> 1.0.1-3
- If depmaps belong to subpackages, each one needs update_maven_depmap
- State minimal versions for jpackage-utils, java-devel, java
- Switch to apache-commons

* Wed Oct 12 2011 David Walluck <dwalluck@redhat.com> 1.0.1-2
- add poms and depmaps to subpackages
- fix Group
- enable tests

* Mon Sep 19 2011 David Walluck <dwalluck@redhat.com> 1.0.1-1
- 1.0.1

* Mon Mar 29 2010 David Walluck <dwakkuck@redhat.com> 0:1.0-0.1.a4.1.2
- disable tests
- fix file/directory ownership

* Wed Sep 2 2009 Deepak Bhole <dbhole@redhat.com> 1.0-0.1.a4.1.1
- Initial build
